﻿using Syncfusion.Windows.Forms;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TreeViewAdv_Customization
{
    public partial class Form1 : MetroForm
    {
        #region Variables

        TreeNodeAdvExt treeNodeAdvExt1;
        TreeNodeAdvExt treeNodeAdvExt2;
        TreeNodeAdvExt treeNodeA3vExt3;
        TreeNodeAdvExt treeNodeAdvExt4;
        TreeNodeAdvExt treeNodeAdvExt5;
        TreeNodeAdvExt treeNodeAdvExt6;
        TreeNodeAdvExt treeNodeAdvExt7;

        #endregion

        #region Constructor

        public Form1()
        {
            InitializeComponent();
            this.PopulateNodes();
            this.Load += Form1_Load;
            this.treeViewAdv1.MouseUp += TreeViewAdv1_MouseUp;
        }

        #endregion

        #region Events

        private void TreeViewAdv1_MouseUp(object sender, MouseEventArgs e)
        {
            if (this.treeViewAdv1.GetNodeAtPoint(e.Location) != null && this.treeViewAdv1.GetNodeAtPoint(e.Location) is TreeNodeAdvExt)
                MessageBox.Show("Node Name is:  " + (this.treeViewAdv1.GetNodeAtPoint(e.Location) as TreeNodeAdvExt).Name.ToString());
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            treeNodeAdvExt1.Name = "Node 0";
            treeNodeAdvExt2.Name = "Node 1";
            treeNodeA3vExt3.Name = "Node 2";
            treeNodeAdvExt4.Name = "Node 3";
            treeNodeAdvExt5.Name = "Node 4";
            treeNodeAdvExt6.Name = "Node 5";
            treeNodeAdvExt7.Name = "Node 6";
        }

        #endregion

        #region Function

        public void PopulateNodes()
        {
            treeNodeAdvExt1 = new TreeNodeAdvExt();
            treeNodeAdvExt2 = new TreeNodeAdvExt();
            treeNodeA3vExt3 = new TreeNodeAdvExt();
            treeNodeAdvExt4 = new TreeNodeAdvExt();
            treeNodeAdvExt5 = new TreeNodeAdvExt();
            treeNodeAdvExt6 = new TreeNodeAdvExt();
            treeNodeAdvExt7 = new TreeNodeAdvExt();
            treeNodeAdvExt1.ChildStyle.EnsureDefaultOptionedChild = true;
            treeNodeAdvExt1.EnsureDefaultOptionedChild = true;
            treeNodeAdvExt1.MultiLine = true;
            treeNodeAdvExt1.Name = "";
            treeNodeAdvExt1.PlusMinusSize = new System.Drawing.Size(9, 9);
            treeNodeAdvExt1.ShowLine = true;
            treeNodeAdvExt1.Text = "Node 0";
            treeNodeAdvExt2.ChildStyle.EnsureDefaultOptionedChild = true;
            treeNodeAdvExt2.EnsureDefaultOptionedChild = true;
            treeNodeAdvExt2.Expanded = true;
            treeNodeAdvExt2.MultiLine = true;
            treeNodeAdvExt2.Name = "";
            treeNodeA3vExt3.ChildStyle.EnsureDefaultOptionedChild = true;
            treeNodeA3vExt3.EnsureDefaultOptionedChild = true;
            treeNodeA3vExt3.MultiLine = true;
            treeNodeA3vExt3.Name = "";
            treeNodeA3vExt3.Optioned = true;
            treeNodeA3vExt3.PlusMinusSize = new System.Drawing.Size(9, 9);
            treeNodeA3vExt3.ShowLine = true;
            treeNodeA3vExt3.Text = "Node 2";
            treeNodeAdvExt4.ChildStyle.EnsureDefaultOptionedChild = true;
            treeNodeAdvExt4.EnsureDefaultOptionedChild = true;
            treeNodeAdvExt4.MultiLine = true;
            treeNodeAdvExt4.Name = "";
            treeNodeAdvExt4.PlusMinusSize = new System.Drawing.Size(9, 9);
            treeNodeAdvExt4.ShowLine = true;
            treeNodeAdvExt4.Text = "Node 3";
            treeNodeAdvExt5.ChildStyle.EnsureDefaultOptionedChild = true;
            treeNodeAdvExt5.EnsureDefaultOptionedChild = true;
            treeNodeAdvExt5.MultiLine = true;
            treeNodeAdvExt5.Name = "";
            treeNodeAdvExt5.PlusMinusSize = new System.Drawing.Size(9, 9);
            treeNodeAdvExt5.ShowLine = true;
            treeNodeAdvExt5.Text = "Node 4";
            treeNodeAdvExt6.ChildStyle.EnsureDefaultOptionedChild = true;
            treeNodeAdvExt6.EnsureDefaultOptionedChild = true;
            treeNodeAdvExt6.MultiLine = true;
            treeNodeAdvExt6.Name = "";
            treeNodeAdvExt6.PlusMinusSize = new System.Drawing.Size(9, 9);
            treeNodeAdvExt6.ShowLine = true;
            treeNodeAdvExt6.Text = "Node 5";
            treeNodeAdvExt7.ChildStyle.EnsureDefaultOptionedChild = true;
            treeNodeAdvExt7.EnsureDefaultOptionedChild = true;
            treeNodeAdvExt7.MultiLine = true;
            treeNodeAdvExt7.Name = "";
            treeNodeAdvExt7.PlusMinusSize = new System.Drawing.Size(9, 9);
            treeNodeAdvExt7.ShowLine = true;
            treeNodeAdvExt7.Text = "Node 6";
            treeNodeAdvExt2.Nodes.AddRange(new Syncfusion.Windows.Forms.Tools.TreeNodeAdv[] {
            treeNodeA3vExt3,
            treeNodeAdvExt4,
            treeNodeAdvExt5,
            treeNodeAdvExt6,
            treeNodeAdvExt7});
            treeNodeAdvExt2.PlusMinusSize = new System.Drawing.Size(9, 9);
            treeNodeAdvExt2.ShowLine = true;
            treeNodeAdvExt2.Text = "Node 1";
            this.treeViewAdv1.Nodes.AddRange(new Syncfusion.Windows.Forms.Tools.TreeNodeAdv[] {
            treeNodeAdvExt1,
            treeNodeAdvExt2});
        }

        #endregion

    }
}
